"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const mapObject = (obj, fn) => Object.keys(obj).reduce((res, key) => {
    const value = obj[key];
    return {
        ...res,
        ...{ [key]: fn(value) },
    };
}, {});
const isObject = (myVar) => myVar && typeof myVar === 'object' ? true : false;
const deepMap = (styles, fn) => {
    const deepMapper = (value => {
        return isObject(value) ? deepMap(value, fn) : fn(value);
    });
    if (Array.isArray(styles)) {
        return styles.map(style => deepMapper(style));
    }
    if (isObject(styles)) {
        return mapObject(styles, deepMapper);
    }
    return styles;
};
exports.default = deepMap;
//# sourceMappingURL=deep-map.js.map